<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | 45.50</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">

  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Orders</a>
      </li>
    </ul>

  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">QuanNM</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Danh sách Orders</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
        </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Danh sách Orders</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Danh sách Orders</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <h2 class="text-center">DANH SÁCH ĐƠN HÀNG</h2>
        <div class="container jumbotron">
            <div class="row form-group">
                <div class="col-md-2">
                    <label>Trạng thái Order:</label>
                </div>
                <div class="col-md-3">
                    <select id="select-trang-thai" class="form-control">
                        <option value="all">All</option>
                        <option value="open">Open</option>
                        <option value="confirmed">Confirmed</option>
                        <option value="cancel">Cancel</option>
                    </select>
                </div>
                <div class="col-md-2">
                    <label>Loai Pizza:</label>
                </div>
                <div class="col-md-3">
                    <select id="select-loai-pizza" class="form-control">
                        <option value="all">All</option>
                        <option value="hawaii">Hawaii</option>
                        <option value="bacon">Bacon</option>
                        <option value="seafood">Seafood</option>
                    </select>
                </div>
                <div class="col-md-2">
                    <button id="btn-filter" class="btn btn-primary form-control">Lọc</button>
                </div>
            </div>
        </div>
        <table id="table-order" class="table table-bordered table-hover table-striped table-warning text-center">
            <thead>
                <tr>
                    <th scope="col">Order Id</th>
                    <th scope="col">Kích cỡ Combo</th>
                    <th scope="col">Loại Pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody>
                
            </tbody>
        </table>
    </div>

    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
<script>
  "use strict";
  $(document).ready(function() {
      // Vùng 1: Khai báo biến toàn cục
      var gOrdersDb = {
          order: [],
          filterOrder: function(paramFilter) {
              var vResult = [];
              // Lọc
              vResult = this.order.filter(function(order) {
                  return ((paramFilter.trangThai == "all" || paramFilter.trangThai.toLowerCase() == order.trangThai.toLowerCase()) &&
                          (paramFilter.loaiPizza == "all" || paramFilter.loaiPizza.toLowerCase() == order.loaiPizza.toLowerCase()))
              });
              return vResult;
          }
      }

      const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";

      const gNAME_COLS = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "chiTiet"];

      const gORDER_ID_COL = 0;
      const gKICH_CO_COL = 1;
      const gLOAI_PIZZA_COL = 2;
      const gNUOC_UONG_COL = 3;
      const gTHANH_TIEN_COL = 4;
      const gHO_VA_TEN_COL = 5;
      const gSO_DIEN_THOAI_COL = 6;
      const gTRANG_THAI_COL = 7;
      const gCHI_TIET_COL = 8;

      var gTableOrder = $('#table-order').DataTable({
          "columns": [
              { "data": gNAME_COLS[gORDER_ID_COL] },
              { "data": gNAME_COLS[gKICH_CO_COL] },
              { "data": gNAME_COLS[gLOAI_PIZZA_COL] },
              { "data": gNAME_COLS[gNUOC_UONG_COL] },
              { "data": gNAME_COLS[gTHANH_TIEN_COL] },
              { "data": gNAME_COLS[gHO_VA_TEN_COL] },
              { "data": gNAME_COLS[gSO_DIEN_THOAI_COL] },
              { "data": gNAME_COLS[gTRANG_THAI_COL] },
              { "data": gNAME_COLS[gCHI_TIET_COL] }
          ],
          "columnDefs": [
              {
                  "targets": gCHI_TIET_COL,
                  "defaultContent": "<i class='fas fa-info btn-detail' alt='Chi tiết' style='color: green'></i>"
              }
          ]
      });


      // Vùng 2: Vùng gán
      onPageLoading();

      $('#table-order').on('click', '.btn-detail', function() {
          onBtnDetailClick(this);
      });

      $('#btn-filter').on('click', onBtnFilterClick);

      // Vùng 3: Khai báo hàm xử lý sự kiện
      // Hàm xử lý khi tải trang
      function onPageLoading() {
          "use strict";
          console.log("Load trang");
          //B1: thu thập dữ liệu (k có)
          //B2: validate dữ liệu (k có)
          //B3: Call api
          callApiGetAllOrders();
          //B4: Xử lý hiển thị
          loadDataToDataTable(gOrdersDb.order);
      }

      // Hàm xử lý khi click các button detail
      function onBtnDetailClick(paramEle) {
          "use strict";
          var vRowClick = $(paramEle).closest('tr');
          var vTable = $('#table-order').DataTable();
          var vDataRow = vTable.row(vRowClick).data();
          console.log(vDataRow);
      }

      // Hàm xử lý khi click filter btn
      function onBtnFilterClick() {
          "use strict";
          //B1: Tạo đối tượng lưu trữ và thu thập dữ liệu
          var vFilterObj = {
              trangThai: "",
              loaiPizza: ""
          };
          getFilterData(vFilterObj);
          console.log(vFilterObj);

          //B2: validate (k cần)

          //B3: Lọc dữ liệu
          var vFilterOrder = gOrdersDb.filterOrder(vFilterObj);

          //B4: Hiển thị
          loadDataToDataTable(vFilterOrder);
      }

      // Vùng 4: Khai báo hàm dùng chung
      // Hàm call api lấy toàn bộ orders
      function callApiGetAllOrders() {
          "use strict";
          $.ajax({
              url: gBASE_URL,
              type:'GET',
              dataType: 'json',
              async: false,
              success: function(result) {
                  gOrdersDb.order = result;
                  console.log(gOrdersDb.order);
              }
          });
      }

      // Hàm load data vào table
      function loadDataToDataTable(paramOrder) {
          "use strict";
          gTableOrder.clear();
          gTableOrder.rows.add(paramOrder);
          gTableOrder.draw();
      }

      // Hàm thu thập data filter
      function getFilterData(paramFilterObj) {
          "use strict";
          paramFilterObj.trangThai = $('#select-trang-thai :selected').val();
          paramFilterObj.loaiPizza = $('#select-loai-pizza :selected').val();
      }

  });
</script>
</body>
</html>
